#ifndef MAZEFIELD_H
#define MAZEFIELD_H

#include <View.h>
#include "graphics.h"

// field informations
#define LEFTSKIP  10
#define RIGHTSKIP  10
#define UPPERSKIP  10
#define LOWERSKIP  10
#define PITCH_X  3
#define PITCH_Y  3
#define MAZE_X  150
#define MAZE_Y  150
#define FIELD_WIDTH (LEFTSKIP+PITCH_X*MAZE_X+RIGHTSKIP)
#define FIELD_HEIGHT (UPPERSKIP+PITCH_Y*MAZE_Y+LOWERSKIP)
// directions
#define UP 0
#define DOWN 1
#define LEFT 2
#define RIGHT 3
#define DIRECTIONS 4
// command for connection
#define DISCONNECT 0
#define CONNECT 1
#define SETONLY 0
#define DRAW 2
#define CONTINUE -2
// search conditions
#define FREE 1
#define WALL 2
#define SELF 4
// for memory management
#define CONSTRUCTIONUNIT 16

struct mawari {
	int nOKs;
	int direction[DIRECTIONS];
};

extern class MazeWindow;
extern class MazeBitmap;
extern class MazeField;

class Maze {
private:
	MazeBitmap *field;
	Maze *neighbor[DIRECTIONS];
	bool connection[DIRECTIONS];
	bool under_construction;
	int x;
	int y;
public:
		Maze( MazeBitmap *, int, int );
void	setneighbor( int, ... );
void	connectwith( int, int, MazeField * );
struct mawari *search( int );
bool	IsFree();
bool	SetUnderConstruction( bool );
bool	IsUnderConstruction();
int	reverse( int );
};

class MazeField : public BView {
private:
MazeWindow *window;
MazeBitmap *field;
Maze	*maze[MAZE_X][MAZE_Y];
thread_id my_thread;
bool	make( int, int );
public:
		MazeField( MazeWindow *, BRect, long );
long	Go();
void	Draw();
void	Draw( BPoint, BPoint );
void	Draw( BRect );
virtual void	Pulse();
void	InitField();
void	construct();
};

#endif
